#!/bin/sh
#
# SSL Ftpd Shell Script.
#
# 1998 Nagoya Institute of technology.
#      Takuto Okuno.
#      usagi@mars.elcom.nitech.ac.jp
#

INSTALLTOP=/usr/local/ssl

# ftpd is ..
FTPD=${INSTALLTOP}/bin/ssl.ftpd

# This is CA files. But you should use CA path option. 
#CAFILES=${INSTALLTOP}/demoCA/cacert.pem:/usr/local/ailabCA/cacert.pem

# CA and CRL link_file's path. And you must create symbolic link to CAfiles.
# ex. ln -s ../cacert.pem `x509 -noout -hash < ../cacert.pem `.0 
#     ln -s ../crl.pem `crl -noout -hash < ../crl.pem`.r0 
CAPATH=${INSTALLTOP}/certs

# Server Certificate and Private_Key file
CERT_KEY=${INSTALLTOP}/certs/ftpd.pem

# SSL Ftpd Secure flags.
# -z secure   ... X509 Strong Auth mode. Only SSL use. And Set Verify=1.
#                 this same as "-z sslonly -z verify=1"
# -z sslonly  ... SSL connect only. Nomal telnet connection is rejected.
# -z verify=n ... n=0 (default)   :All SSL Session accepted.
#             ... n=1 PEER_VERIFY :require client certificate
#                                 :verify cert's CAdepth,CRLs
# -z signonly ... if you select "-z secure" mode, this mode permits login
#                 only "/etc/ssl.certusers" users.
#SSLSECURES="-z secure -z signonly"     # most strong.
SSLSECURES="-z sslonly -z verify=1"    # client certificate verify.
#SSLSECURES="-z sslonly"

# Debug options.
#SSLDEBUG="-z verbose -z debug"
#FTPDEBUG="-z standalone=3320"

## execute internet telnetd
${FTPD} $SSLDEBUG $SSLSECURES -z cafile=${CAFILES} -z capath=${CAPATH} -z cert=${CERT_KEY} $FTPDEBUG


