/* 
 * The modifications to support SSLeay were done by Tim Hudson
 * tjh@mincom.oz.au
 *
 * You can do whatever you like with these patches except pretend that
 * you wrote them. 
 *
 * Email ssl-users-request@mincom.oz.au to get instructions on how to
 * join the mailing list that discusses SSLeay and also these patches.
 *
 */

/*
 * Copyright (c) 1985, 1989 Regents of the University of California.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the University of
 *	California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#ifndef lint
char copyright[] =
"@(#) Copyright (c) 1985, 1989 Regents of the University of California.\n\
 All rights reserved.\n";
#endif /* not lint */

#ifndef lint
static char sccsid[] = "@(#)main.c	5.18 (Berkeley) 3/1/91";
#endif /* not lint */

/*
 * FTP User Program -- Command Interface.
 */
#include "ftp_var.h"
#include <sys/socket.h>
#include <sys/ioctl.h>
#include <sys/types.h>

#include <arpa/ftp.h>

#include <signal.h>
#include <stdio.h>
#include <errno.h>
#include <ctype.h>
#include <netdb.h>
#include <pwd.h>

uid_t	getuid();
void	intr(), lostpeer();
extern	char *home;
char	*getlogin();

#ifdef USE_SSL

/* icky way of doing things ... */
#include "sslapp.h"

SSL *ssl_con;
SSL *ssl_data_con;
int ssl_data_active_flag=0;

/* for the moment this is a compile time option only --tjh */
int ssl_encrypt_data=1;
int ssl_enabled=1;

char *my_ssl_key_file=NULL;
char *my_ssl_cert_file=NULL;

BIO *bio_err=NULL;

#endif /* USE_SSL */

#ifdef USE_SOCKS
int socks_flag=1;        /* socks usage is now the default */
#endif /* USE_SOCKS */

#ifdef PASVHACK
int pasv_hack=1;
#endif /* PASVHACK */

main(argc, argv)
	char *argv[];
{
	register char *cp;
	int top;
	struct passwd *pw = NULL;
	char homedir[MAXPATHLEN];
	char *optarg;
	char *argv0;

        argv0=argv[0];

	doglob = 1;
	interactive = 1;
	autologin = 1;
	argc--, argv++;
	while (argc > 0 && **argv == '-') {
	        optarg=*(argv+1);
		for (cp = *argv + 1; *cp; cp++)
			switch (*cp) {

			case 'd':
				options |= SO_DEBUG;
				debug++;
				break;
			
			case 'v':
				verbose++;
				break;

			case 't':
				trace++;
				break;

			case 'i':
				interactive = 0;
				break;

			case 'n':
				autologin = 0;
				break;

			case 'g':
				doglob = 0;
				break;
#ifdef USE_SSL
			case 'z':
				if (strcmp(optarg, "debug") == 0 ) {
				    ssl_debug_flag=1;
				}
				if (strcmp(optarg, "ssl") == 0 ) {
				    ssl_only_flag=1;
				}
				/* disable *all* ssl stuff */
				if ( (strcmp(optarg, "!ssl") == 0 ) || 
				     (strcmp(optarg, "nossl") == 0 ) )  {
				    ssl_enabled=0;
				}
				if (strcmp(optarg, "secure") == 0 ) {
				    ssl_secure_flag=1;
				}
				if (strcmp(optarg, "certsok") == 0 ) {
				    ssl_certsok_flag=1;
				}
				if (strcmp(optarg, "verbose") == 0 ) {
				    ssl_verbose_flag=1;
				}
				if (strncmp(optarg, "verify=", strlen("verify=")) == 0 ) {
				    ssl_verify_flag=atoi(optarg+strlen("verify="));
				    printf("set option verify:%d\n",ssl_verify_flag);
				}
				if (strncmp(optarg, "cert=", strlen("cert=")) == 0 ) {
				    my_ssl_cert_file=optarg+strlen("cert=");
				    printf("set option cert:%s\n",my_ssl_cert_file);
				}
				if (strncmp(optarg, "key=", strlen("key=")) == 0 ) {
				    my_ssl_key_file=optarg+strlen("key=");
				    printf("set option key:%s\n",my_ssl_key_file);
				}
/** oku 1998/8 added **/
				if (strncmp(optarg, "cafile=",strlen("cafile="))==0){
				    ssl_ca_file=optarg+strlen("cafile=");
				    printf("set option CA file:%s\n",ssl_ca_file);
				}
				if (strncmp(optarg, "capath=",strlen("capath="))==0){
				    ssl_ca_path=optarg+strlen("capath=");
				    printf("set option CA path:%s\n",ssl_ca_path);
				}
#ifdef USE_PKCS12
				if (strncmp(optarg, "p12=",strlen("p12="))==0){
				    ssl_p12_file=optarg+strlen("p12=");
				    printf("set option p12:%s\n",ssl_p12_file);
				}
				if (strncmp(optarg,"p12twopass",strlen("p12twopass"))==0){
				    p12_twopass=1;
				}
#endif /* USE_PKCS12 */
/** oku 1998/8 end **/
				if (strcmp(optarg, "socks") == 0 ) {
#ifdef USE_SOCKS
				    socks_flag=1;
#else /* !USE_SOCKS */
                                    fprintf(stderr,"No SOCKS support\n");
				    fflush(stderr);
#endif /* USE_SOCKS */
				}
				if ( (strcmp(optarg, "!socks") == 0 ) || 
				     (strcmp(optarg, "nosocks") == 0 ) )  {
#ifdef USE_SOCKS
				    socks_flag=0;
#else /* !USE_SOCKS */
                                    fprintf(stderr,"No SOCKS support\n");
				    fflush(stderr);
#endif /* USE_SOCKS */
				}
                                if ( (strcmp(optarg, "!pasv") == 0 ) ||
                                     (strcmp(optarg, "nopasv") == 0 ) ) {
#ifdef PASVHACK
                                    pasv_hack=0;
#else /* !PASVHACK */
                                    fprintf(stderr,"No PASVHACK support\n");
				    fflush(stderr);
#endif /* PASVHACK */
                                }

                                /* we have swallowed an extra arg */
				argc--;
                                argv++;
				break;
#endif /* USE_SSL */

#ifndef USE_SSL
                case 'z':
                        if (strcmp(optarg, "socks") == 0 ) {
#ifdef USE_SOCKS
                            socks_flag=1;
#else /* !USE_SOCKS */
                            fprintf(stderr,"No SOCKS support\n");
                            fflush(stderr);
#endif /* USE_SOCKS */
                        }
			if ( (strcmp(optarg, "!socks") == 0 ) || 
			     (strcmp(optarg, "nosocks") == 0 ) )  {
#ifdef USE_SOCKS
                            socks_flag=0;
#else /* !USE_SOCKS */
                            fprintf(stderr,"No SOCKS support\n");
                            fflush(stderr);
#endif /* USE_SOCKS */
                        }
                        if (strcmp(optarg, "socks") == 0 ) {
                            socks_flag=1;
                        }
                        break;
#endif /* !USE_SSL */



			default:
				fprintf(stdout,
				  "ftp: %c: unknown option\n", *cp);
				exit(1);
			}
		argc--, argv++;
	}

#ifdef USE_SOCKS
        if (socks_flag) 
	    SOCKSinit(argv0);
#endif /* USE_SOCKS */

        /* this was moved from before the arg processing to here
	 * as if we build for socks then it wipes out the service
	 * area with the getservbyname return for "socks" ... the
	 * joys of a single static area and not copying the 
	 * results of a lookup --tjh
	 */
	sp = getservbyname("ftp", "tcp");
	if (sp == 0) {
		fprintf(stderr, "ftp: ftp/tcp: unknown service\n");
		exit(1);
	}

	fromatty = isatty(fileno(stdin));
	if (fromatty)
		verbose++;
	cpend = 0;	/* no pending replies */
	proxy = 0;	/* proxy not active */
	crflag = 1;	/* strip c.r. on ascii gets */
	sendport = -1;	/* not using ports */
	/*
	 * Set up the home directory in case we're globbing.
	 */
	cp = getlogin();
	if (cp != NULL) {
		pw = getpwnam(cp);
	}
	if (pw == NULL)
		pw = getpwuid(getuid());
	if (pw != NULL) {
		home = homedir;
		(void) strcpy(home, pw->pw_dir);
	}

#ifdef USE_SSL
/** oku 1998/8 added **/

	if (my_ssl_cert_file!=NULL)
	    ssl_cert_file=my_ssl_cert_file;

/** oku 1998/8 **/
        if (ssl_enabled) {
	    if (!do_ssleay_init(0)) {
		fprintf(stderr,"ftp: SSLeay initialisation failed\n");
		fflush(stderr);
		ERR_print_errors_fp(stderr);
		exit(1);
	    }
	}
#endif /* USE_SSL */

	if (argc > 0) {
		if (setjmp(toplevel))
			exit(0);
		(void) signal(SIGINT, intr);
		(void) signal(SIGPIPE, lostpeer);
		setpeer(argc + 1, argv - 1);
	}
	top = setjmp(toplevel) == 0;
	if (top) {
		(void) signal(SIGINT, intr);
		(void) signal(SIGPIPE, lostpeer);
	}
	for (;;) {
		cmdscanner(top);
		top = 1;
	}
}

void
intr()
{

	longjmp(toplevel, 1);
}

void
lostpeer()
{
	extern FILE *cout;
	extern int data;

	if (connected) {
		if (cout != NULL) {
			(void) shutdown(fileno(cout), 1+1);
			(void) fclose(cout);
			cout = NULL;
		}
		if (data >= 0) {
			(void) shutdown(data, 1+1);
			(void) close(data);
			data = -1;
		}
		connected = 0;
	}
	pswitch(1);
	if (connected) {
		if (cout != NULL) {
			(void) shutdown(fileno(cout), 1+1);
			(void) fclose(cout);
			cout = NULL;
		}
		connected = 0;
	}
	proxflag = 0;
	pswitch(0);
}

/*char *
tail(filename)
	char *filename;
{
	register char *s;
	
	while (*filename) {
		s = rindex(filename, '/');
		if (s == NULL)
			break;
		if (s[1])
			return (s + 1);
		*s = '\0';
	}
	return (filename);
}
*/
/*
 * Command parser.
 */
cmdscanner(top)
	int top;
{
	register struct cmd *c;
	register int l;
	struct cmd *getcmd();
	extern int help();

	if (!top)
		(void) putchar('\n');
	for (;;) {
		if (fromatty) {
			printf("ftp> ");
			(void) fflush(stdout);
		}
		if (fgets(line, sizeof line, stdin) == NULL)
			quit();
		l = strlen(line);
		if (l == 0)
			break;
		if (line[--l] == '\n') {
			if (l == 0)
				break;
			line[l] = '\0';
		} else if (l == sizeof(line) - 2) {
			printf("sorry, input line too long\n");
			while ((l = getchar()) != '\n' && l != EOF)
				/* void */;
			break;
		} /* else it was a line without a newline */
		makeargv();
		if (margc == 0) {
			continue;
		}
		c = getcmd(margv[0]);
		if (c == (struct cmd *)-1) {
			printf("?Ambiguous command\n");
			continue;
		}
		if (c == 0) {
			printf("?Invalid command\n");
			continue;
		}
		if (c->c_conn && !connected) {
			printf("Not connected.\n");
			continue;
		}
		(*c->c_handler)(margc, margv);
		if (bell && c->c_bell)
			(void) putchar('\007');
		if (c->c_handler != help)
			break;
	}
	(void) signal(SIGINT, intr);
	(void) signal(SIGPIPE, lostpeer);
}

struct cmd *
getcmd(name)
	register char *name;
{
	extern struct cmd cmdtab[];
	register char *p, *q;
	register struct cmd *c, *found;
	register int nmatches, longest;

	longest = 0;
	nmatches = 0;
	found = 0;
	for (c = cmdtab; p = c->c_name; c++) {
		for (q = name; *q == *p++; q++)
			if (*q == 0)		/* exact match? */
				return (c);
		if (!*q) {			/* the name was a prefix */
			if (q - name > longest) {
				longest = q - name;
				nmatches = 1;
				found = c;
			} else if (q - name == longest)
				nmatches++;
		}
	}
	if (nmatches > 1)
		return ((struct cmd *)-1);
	return (found);
}

/*
 * Slice a string up into argc/argv.
 */

int slrflag;

makeargv()
{
	char **argp;
	char *slurpstring();

	margc = 0;
	argp = margv;
	stringbase = line;		/* scan from first of buffer */
	argbase = argbuf;		/* store from first of buffer */
	slrflag = 0;
	while (*argp++ = slurpstring())
		margc++;
}

/*
 * Parse string into argbuf;
 * implemented with FSM to
 * handle quoting and strings
 */
char *
slurpstring()
{
	int got_one = 0;
	register char *sb = stringbase;
	register char *ap = argbase;
	char *tmp = argbase;		/* will return this if token found */

	if (*sb == '!' || *sb == '$') {	/* recognize ! as a token for shell */
		switch (slrflag) {	/* and $ as token for macro invoke */
			case 0:
				slrflag++;
				stringbase++;
				return ((*sb == '!') ? "!" : "$");
				/* NOTREACHED */
			case 1:
				slrflag++;
				altarg = stringbase;
				break;
			default:
				break;
		}
	}

S0:
	switch (*sb) {

	case '\0':
		goto OUT;

	case ' ':
	case '\t':
		sb++; goto S0;

	default:
		switch (slrflag) {
			case 0:
				slrflag++;
				break;
			case 1:
				slrflag++;
				altarg = sb;
				break;
			default:
				break;
		}
		goto S1;
	}

S1:
	switch (*sb) {

	case ' ':
	case '\t':
	case '\0':
		goto OUT;	/* end of token */

	case '\\':
		sb++; goto S2;	/* slurp next character */

	case '"':
		sb++; goto S3;	/* slurp quoted string */

	default:
		*ap++ = *sb++;	/* add character to token */
		got_one = 1;
		goto S1;
	}

S2:
	switch (*sb) {

	case '\0':
		goto OUT;

	default:
		*ap++ = *sb++;
		got_one = 1;
		goto S1;
	}

S3:
	switch (*sb) {

	case '\0':
		goto OUT;

	case '"':
		sb++; goto S1;

	default:
		*ap++ = *sb++;
		got_one = 1;
		goto S3;
	}

OUT:
	if (got_one)
		*ap++ = '\0';
	argbase = ap;			/* update storage pointer */
	stringbase = sb;		/* update scan pointer */
	if (got_one) {
		return(tmp);
	}
	switch (slrflag) {
		case 0:
			slrflag++;
			break;
		case 1:
			slrflag++;
			altarg = (char *) 0;
			break;
		default:
			break;
	}
	return((char *)0);
}

#define HELPINDENT (sizeof ("directory"))

/*
 * Help command.
 * Call each command handler with argc == 0 and argv[0] == name.
 */
help(argc, argv)
	int argc;
	char *argv[];
{
	extern struct cmd cmdtab[];
	register struct cmd *c;

	if (argc == 1) {
		register int i, j, w, k;
		int columns, width = 0, lines;
		extern int NCMDS;

		printf("Commands may be abbreviated.  Commands are:\n\n");
		for (c = cmdtab; c < &cmdtab[NCMDS]; c++) {
			int len = strlen(c->c_name);

			if (len > width)
				width = len;
		}
		width = (width + 8) &~ 7;
		columns = 80 / width;
		if (columns == 0)
			columns = 1;
		lines = (NCMDS + columns - 1) / columns;
		for (i = 0; i < lines; i++) {
			for (j = 0; j < columns; j++) {
				c = cmdtab + j * lines + i;
				if (c->c_name && (!proxy || c->c_proxy)) {
					printf("%s", c->c_name);
				}
				else if (c->c_name) {
					for (k=0; k < strlen(c->c_name); k++) {
						(void) putchar(' ');
					}
				}
				if (c + lines >= &cmdtab[NCMDS]) {
					printf("\n");
					break;
				}
				w = strlen(c->c_name);
				while (w < width) {
					w = (w + 8) &~ 7;
					(void) putchar('\t');
				}
			}
		}
		return;
	}
	while (--argc > 0) {
		register char *arg;
		arg = *++argv;
		c = getcmd(arg);
		if (c == (struct cmd *)-1)
			printf("?Ambiguous help command %s\n", arg);
		else if (c == (struct cmd *)0)
			printf("?Invalid help command %s\n", arg);
		else
			printf("%-*s\t%s\n", HELPINDENT,
				c->c_name, c->c_help);
	}
}
